码迷,mamicode.com
首页 > 其他好文 > 详细

Two Sum

时间:2015-01-12 19:23:04      阅读:124      评论:0      收藏:0      [点我收藏+]

标签:leetcode

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int[] res = new int[2];
        Map<Integer,Integer> map =  new HashMap<Integer,Integer>();
        for(int i = 0 ; i < numbers.length; i++){
            if(!map.containsKey(target - numbers[i])){
                map.put(numbers[i],i+1);
            }else{
                res[0] = map.get(target - numbers[i]);
                res[1] = i + 1;
                break;
            }
        }
        return res;
    }
}

Runtime: 245 ms

这样的题竟然也耗费了一个小时,汗颜啊

一开始看的时候,感觉很简单,然后就两个for循环,结果超时了,然后就想怎么把时间缩短,

1,先排序,然后再查找。排序最快是O(nlogn),查找的话是O(n);

2,用空间换时间,hash的查找速度很快,所以采用HashMap。

陷入的误区,将找到的小于等于target的索引值和对应值加入map中,然后在从map中遍历到符合条件的值,实现也是超时的。

思路还是很简单的。

Two Sum

标签:leetcode

原文地址:http://blog.csdn.net/havedream_one/article/details/42645023

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!